local AssignSoldier = ...

-- Register all stone gate set building parts and their properties
AssignSoldier:dofile("scripts/compPathAccess.lua")
AssignSoldier:dofile("scripts/compPathAEnd.lua")
AssignSoldier:dofile("scripts/basicWorkplace.lua")
AssignSoldier:dofile("scripts/behavior_tree.lua")

-- Register the stone gate set monument
if _flagSg7 then
-- Adds the specific materials od Soldier Assignment to the already existing list of themes
    function configureMaterialSet2(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _defaultMaterial, _custom)
        function configureSimpleRoofAccessMaterial(_core)
            if _defaultMaterial then
                return _assignSoldierPrefix .. "_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
            else
                return _CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
            end
        end
        function configureWallAccessMaterial(_core)
            if _defaultMaterial then
                return _assignSoldierPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
            else
                return _CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
            end
        end

        AssignSoldier:log("init configureMaterialSet")
        local materialSet = configureMaterialSet(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _defaultMaterial, _custom)
        AssignSoldier:log("init configureMaterialSet")
    if _colorRoof == "RED_TILE" then
        _color = "RED"
        _material = "ROOF"
    elseif _colorRoof == "BLUE_TILE" then
        _color = "BLUE"
        _material = "ROOF"
    elseif _colorRoof == "BROWN_TILE" then
        _color = "BROWN"
        _material = "ROOF"
    elseif _colorRoof == "LIGHT_GREY_TILE" then
        _color = "GREY"
        _material = "ROOF"
    elseif _colorRoof == "DARK_GREY_TILE" then
        _color = "GREY2"
        _material = "ROOF"
    elseif _colorRoof == "RED_SHINGLE" then
        _color = "RED"
        _material = "WROOF"
    elseif _colorRoof == "BLUE_SHINGLE" then
        _color = "BLUE"
        _material = "WROOF"
    elseif _colorRoof == "BROWN_SHINGLE" then
        _color = "BROWN"
        _material = "WROOF"
    elseif _colorRoof == "YELLOW_SHINGLE" then
        _color = "YELLOW"
        _material = "WROOF"
    elseif _colorRoof == "GREEN_SHINGLE" then
        _color = "GREEN"
        _material = "WROOF"
    elseif _colorRoof == "WOODEN_MANOR" then
        _color = "MANOR"
        _material = "WROOF"
    elseif _colorRoof == "STONE_MANOR" then
        _color = "MANOR2"
        _material = "WROOF"
    elseif _colorRoof == "BROWN_MONASTERY" then
        _color = "BROWN_MONASTERY"
        _material = "ROOF"
    elseif _colorRoof == "BLUE_MONASTERY" then
        _color = "BLUE_MONASTERY"
        _material = "ROOF"
    elseif _colorRoof == "PURPLE_MONASTERY" then
        _color = "PURPLE_MONASTERY"
        _material = "ROOF"
    elseif _colorRoof == "STRAW" then
        _color = "STRAW"
        _material = "ROOF"
    end
    if _colorWall == "STONE_MANOR" then
            _colorWall = "MANOR2"
    end
    if _colorCrenellation == "STONE_MANOR" then
            _colorCrenellation = "BLUE"
    end
    if _colorBasement == "STONE_MANOR" then
            _colorBasement = "MANOR2"
    end
    if _colorFloorGround == "WHITE_STONE" then
            _colorFloorGround = "WHITE"
    elseif _colorFloorGround == "RED_STONE" then
            _colorFloorGround = "ROSE"
    end
        table.insert(materialSet.MaterialList, configureSimpleRoofAccessMaterial("OTOWER"))
        table.insert(materialSet.MaterialList, configureWallAccessMaterial("OTOWER"))
        AssignSoldier:log("end configureMaterialSet" .. tostring(materialSet))
        return materialSet
    end


    AssignSoldier:override({
        Id = _StoneGateSetPrefix .. "_MONUMENT",
        BuildingPartSetList = {
                Action = "APPEND",
		{
			Name = _StoneGateSetPrefix .. "_ENTRANCE_PARTSETLIST_NAME",
                	BuildingPartList = {
                            _assignSoldierPrefix .. "_KEEP_TRAP_ACCESS_PART",
                            _assignSoldierPrefix .. "_SMALL_GATE_ACCESS_R_PART",
                            _assignSoldierPrefix .. "_SMALL_GATE_ACCESS_L_PART",
                            _assignSoldierPrefix .. "_OCTOGONAL_TOWER_ACCESS_PART",
                        }
                }
        },
        MaterialSetList = configureMaterialSetList(configureMaterialSet2)
    })
end
